<?php

defined( 'ABSPATH' ) || exit;

/**
 * 1.- Creación del usuario supervision por una sola vez
 */

$GLOBALS['multiple']='multiple';

function usuariopaypal()
{
	if(get_role("shop_supervisor") !== null){
		add_role( 'shop_supervisor', 'Shop Supervisor', get_role( 'shop_manager' )->capabilities);
		$admin = get_role('administrator');
		$admin->add_cap('ver_paypals');
	}
	$despa = get_role('shop_manager');
	$despa->add_cap('ver_paypals');

	if(!username_exists('supervision'))
	{
		$user_id = wp_create_user( 'supervision', 'Supervision.2021*', 'supervision@windowsandoffice.com' );
		$user = new WP_User( $user_id );
		$user->set_role( 'shop_supervisor' );
		
		$super = get_role('shop_supervisor');
		$super->add_cap('ver_paypals');
	}
	if(!username_exists('despacho'))
	{
		$user_id = wp_create_user( 'despacho', 'Despacho.2021*', 'despacho@windowsandoffice.com' );
		$user = new WP_User( $user_id );
		$user->set_role( 'shop_manager' );

		$despa = get_role('shop_supervisor');
		$despa->add_cap('ver_paypals');
	}
	$user = wp_get_current_user();
	$role = $user->roles;

}//fin de funcion usuariopaypal

add_action( 'admin_init', 'usuariopaypal' );

/**
 * 2.- Si tiene privilegio 'ver_paypals' registra un new_post_type
 */

add_action('init', 'register_new_post_type');

function register_new_post_type()
{
	if(current_user_can('ver_paypals')){
		$args = array(
			'public' => true,
			'labels' => array(
			'name' => 'Paypals',
			'singular_name' => 'Paypal',
			'all_items' => 'Todos los Paypals',
			'add_new' => 'Agregar nuevo Paypal',
			'add_new_item' => 'Agregar nuevo Paypal',
			'edit_item' => 'Editar Paypal',
			'new_item' => 'Nuevo Paypal',
			'view_item' => 'Ver Paypal',
			'search_items' => 'Buscar Paypals',
			'not_found' => 'No se han encontrado Paypals',
			'not_found_in_trash' => 'No se han encontrado Paypals en la Papelera'
			),
		 'supports' => array( 'title' )
		);

		register_post_type('Paypals', $args);
	}//fin de si es admin
}//fin de funcion
	
/**
 * 2.1.- Llama funcion para agregar los los meta boxes para el Custom Post Type Paypal
 * https://developer.wordpress.org/reference/functions/add_meta_box/
 */

function paypal_register_meta_boxes()
{
	add_meta_box('Paypal-Parameters', 'Parametros', 'paypal_output_meta_box', 'Paypals', 'normal', 'high');
}

/**
 * 2.2 Inputs para cada nuevo campo personalizado (dentro del meta box)
 */
function paypal_output_meta_box($post)
{
	// Los campos se graban en la base de datos con un subrayado bajo como prefijo
	// WP indica así por defecto que son campos metas
	//cambiar aqui
	$options = get_option( '_paypal_options' );//en el sitio actual NO SIRVE
	$ppoptions = get_paypal_options();//en el servidor paypal
	$liveAPIUsername = get_post_meta($post->ID, '_liveAPIUsername', true);
	$liveAPIPassword = get_post_meta($post->ID, '_liveAPIPassword', true);
	$liveAPISignature = get_post_meta($post->ID, '_liveAPISignature', true);

	$liveEmailAddress = get_post_meta($post->ID, '_liveEmailAddress', true);
	$liveMerchantId = get_post_meta($post->ID, '_liveMerchantId', true);
	$liveClientId = get_post_meta($post->ID, '_liveClientId', true);
	$liveSecretKey = get_post_meta($post->ID, '_liveSecretKey', true);

	$ppcategory = get_post_meta($post->ID, '_ppcategory', true);
	$ppdaysales = get_post_meta($post->ID, '_ppdaysales', true);
	$pplifetimesales = get_post_meta($post->ID, '_pplifetimesales', true);
	$ppstatus = get_post_meta($post->ID, '_ppstatus', true);
	$forsites = get_post_meta($post->ID, '_forsites', true);
	$forsite = get_post_meta($post->ID, '_forsite', true);

	//$ppactivesales = get_post_meta($post->ID, '_ppactivesales', true);
	//$ppmonthsales = get_post_meta($post->ID, '_ppmonthsales', true);
	$ppmonthlimit = get_post_meta($post->ID, '_ppmonthlimit', true);
	echo "<style>
		.cpt_1 {
			float:left;
			width:160px;
			//border:solid 1px red;
		}
		.cpt_2 {
			width:500px;
			//border:solid 1px blue;
		}
		.cpt_2 input, select {
			width:300px;
		}
	</style>";
	echo "
	<div style='float:left;width:48%;padding-bottom:150px;'>";
	if ($options['checkout']=='S'){;
		wp_nonce_field( 'graba_paypal', 'paypal_nonce' );
		echo " 
		<div style='border:none 1px gray;border-radius:5px;'>
			<div class='cpt_1'><label for='liveAPIUsername'>" . __('Live API Username: ', 'pluginwao') . "</label></div>
			<div class='cpt_2'><input type='text' name='liveAPIUsername' id='liveAPIUsername' value='" . esc_attr($liveAPIUsername) . "'></div>
			<br>
			<div class='cpt_1'><label for='liveAPIPassword'>" . __('Live API Password: ', 'pluginwao') . "</label></div>
			<div class='cpt_2'><input type='text' name='liveAPIPassword' id='liveAPIPassword' value='" . esc_attr($liveAPIPassword) . "'></div>
			<br>
			<div class='cpt_1'><label for='liveAPISignature'>" . __('Live API Signature: ', 'pluginwao') . "</label></div>
			<div class='cpt_2'><input type='text' name='liveAPISignature' id='liveAPISignature' value='" . esc_attr($liveAPISignature) . "'></div>
		</div>";
	}
	
	echo "
		<div style='padding-bottom:20px;margin-top:18px;'>
			<div class='cpt_1'><label for='ppcategory' style='padding-right:67px;'>" . __('Category: ', 'pluginwao') . "</label></div>
			";	
			$checked = $ppcategory=="r"||empty($category)?"checked":"";
			echo '
			<div class="cpt_2">
				<span style="border-radius:5px;background-color:Pink;border:solid 1px Crimson;padding:5px;margin-right:5px;"><input style="width:14px" type="radio" id="ppcategory" name="ppcategory" value="r" '.$checked.'><label for="ppcategory" >Red</label></span>'; 
				$checked = $ppcategory=="y"?"checked":"";
				echo '	<span style="border-radius:5px;background-color:LemonChiffon;border:solid 1px #FFA500;padding:5px;margin-right:5px;"><input style="width:14px" type="radio" id="ppcategory" name="ppcategory" value="y" '.$checked.'><label for="ppcategory" >Yellow</label></span>'; 
				$checked = $ppcategory=="g"?"checked":"";
				echo '	<span style="border-radius:5px;background-color:#E9F5F0;border:solid 1px YellowGreen;padding:5px;margin-right:5px;"><input style="width:14px" type="radio" id="ppcategory" name="ppcategory" value="g" '.$checked.'><label for="ppcategory" >Green</label></span>
			</div>
		</div>';
	if(is_multisite()){
		$sites = get_sites(array('archived'=>0));
		echo('<div class="cpt_1"><label for="forsite">' . __('Site: ', 'pluginwao') . '</label></div>');
		$multiple = $options['multiple_countries']=='M'?"multiple":"";
		$m=$options['multiple_countries']=='M'?true:false;
		if(empty($forsite)){ // si forsite esta vacio es porque es la primera actualizacion
			$new_forsite=get_post_meta($post->ID,'_forsites',true);
			update_post_meta($post->ID, '_forsite', $new_forsite[0]);
			$forsite = get_post_meta($post->ID, '_forsite', true);
		}else{

		}
		$names=$m?"name='forsites[]' id='forsites' multiple":"name='forsite' id='forsite' >";
		echo '
			<div class="cpt_2">
				<select '.$names.'>
					<option value="0" >Sin sitio</option>';
		foreach ( $sites as $site ) {
			switch_to_blog( $site->blog_id );
			if (!str_contains(strtolower($site->blogname), 'manuals')){
				//descomentar para multiselect
				if($m){
					if($forsites<>FALSE){
						$sel=in_array($site->blog_id,$forsites)?"selected":"";
					}//if forsites false END
				}else{
					$sel=$forsite==$site->blog_id?"selected":"";
				}
				echo "<option value='".$site->blog_id."' ".$sel." >".$site->blogname."</option>";
			}
			restore_current_blog();
		}//fin de foreach
		echo "	</select>
			</div>";	
	}//fin de is_multisite

	echo "</div>";
	echo "<div style='float:right;width:48%;text-align:left;'>";

	if ($options['payments']=='S'){;
		echo "<div style='border:solid 1px gray;border-radius:5px;padding:10px'>";

		echo('<label for="liveEmailAddress">' . __('Live Email Address: ', 'pluginwao') . '</label>');
		echo('<input type="text" name="liveEmailAddress" id="liveEmailAddress" style="width:300px;margin-left:18px;" value="' . esc_attr($liveEmailAddress) . '">');
		echo '<i style="color:gray;padding-left:5px;">El email de la cuenta paypal.</i><br><br>';

		echo('<label for="liveMerchantId">' . __('Live Merchant ID: ', 'pluginwao') . '</label>');
		echo('<input type="text" name="liveMerchantId" id="liveMerchantId" style="width:300px;margin-left:26px;" value="' . esc_attr($liveMerchantId) . '">');
		echo '<i style="color:gray;padding-left:5px;">En cuenta paypal navegar a: account->settings/businnes information.</i><br><br>';

		echo('<label for="liveClientId">' . __('Live Client ID: ', 'pluginwao') . '</label>');
		echo('<input type="text" name="liveClientId" id="liveClientId" style="width:300px;margin-left:48px;" value="' . esc_attr($liveClientId) . '">');
		echo '<i style="color:gray;padding-left:5px;">Para obtener (Client ID) y (Secret Key) en la cuenta Paypal, abrir <a href="https://developer.paypal.com" target="_blank">https://developer.paypal.com</a> y clic en "Log into Dashboard".</i><br><br>';

		echo('<label for="liveSecretKey">' . __('Live Secret Key: ', 'pluginwao') . '</label>');
		echo('<input type="text" name="liveSecretKey" id="liveSecretKey" style="width:300px;margin-left:40px;" value="' . esc_attr($liveSecretKey) . '"><br><br>');

		echo "</div>";
	}
	echo '
		<div class="cpt_1"><label for="ppmonthlimit">' . __('Monthly Limit: ', 'pluginwao') . '</label></div>
		<div class="cpt_2"><input type="text" name="ppmonthlimit" id="ppmonthlimit" value="' . esc_attr($ppmonthlimit) . '"></div><br>
		<div class="cpt_1"><label for="ppstatus">' . __('Paypal Status: ', 'pluginwao') . '</label></div>
		<div class="cpt_2">
			<select name="ppstatus" id="ppstatus"  >';
				$selected=$ppstatus=="Activo"?'selected':'';
				if($selected=='selected'){
					echo('<option value="Activo" '.$selected.'>Activo</option>');
				}else{
					$selected=$ppstatus=="Reserva"?'selected':'';
					echo('<option value="Reserva" '.$selected.'>Reserva</option>');
					$selected=$ppstatus=="En_revision"?'selected':'';
					echo('<option value="En_revision" '.$selected.'>En revision</option>');
				}
		echo '</select>
		</div>
	</div>
	<div style="clear:both"></div>';

}
add_action('add_meta_boxes', 'paypal_register_meta_boxes');

/**
 * 2.3 Graba los campos del formulario del meta box
 * @param int $post_id Post ID
 */

function my_alert2(){
	$message = "<p>Paypal fields can't to be empty</p>";	
	echo "<div class='notice notice-alert id-dismissible'>";	
	echo $message;	
	echo "</div>";	
	
}

function paypal_save_meta_boxes($post_id)
{

	// Comprueba que el nonce es correcto para evitar ataques CSRF
	if ( !isset($_POST['paypal_nonce']) || ! wp_verify_nonce( $_POST['paypal_nonce'], 'graba_paypal') ) {
		if ( ! wp_verify_nonce( $_POST[ '_inline_edit' ], 'inlineeditnonce' ) ) {
			return;
		}else{
			$ppstatus = sanitize_text_field($_POST['ppstatus']);
			update_post_meta($post_id, '_ppstatus', $ppstatus);
			return;
		}
		return $post_id;
	}
	// Comprueba que el tipo de post es paypal
	if ($GLOBALS['paypal_cpt'] != $_POST['post_type']) {
		return $post_id;
	}

	// Comprueba que el usuario actual tiene permiso para editar esto
	if (!current_user_can('edit_post', $post_id)) {
		return $post_id;
	}

	// Ahora puedes grabar los datos con tranquilidad
	// Observa que cuando vienen del formulario los campos meta no vienen con el prefijo subrayado bajo pero cuando los grabas en el post hay que poner el prefijo, igual que cuando los leías del post
	// cambiar aqui
	$liveAPIUsername = sanitize_text_field($_POST['liveAPIUsername']);
	$liveAPIPassword = sanitize_text_field($_POST['liveAPIPassword']);
	$liveAPISignature = sanitize_text_field($_POST['liveAPISignature']);
//	$liveEmailAddress = sanitize_text_field($_POST['liveEmailAddress']);

	if ($_GLOBALS['paypal_cpt']=='paypals'&&(empty($liveAPIUsername)||empty($liveAPIPassword)||empty($liveAPISignature))){
		add_action( 'admin_notices', 'my_alert2');
		return;
	}


	if(!empty($liveAPIUsername)){
		update_post_meta($post_id, '_liveAPIUsername', $liveAPIUsername);
	}
	if(!empty($liveAPIPassword)){
		update_post_meta($post_id, '_liveAPIPassword', $liveAPIPassword);
	}
	if(!empty($liveAPISignature)){
		update_post_meta($post_id, '_liveAPISignature', $liveAPISignature);
	}

	$liveEmailAddress = sanitize_text_field($_POST['liveEmailAddress']);
	$liveMerchantId = sanitize_text_field($_POST['liveMerchantId']);
	$liveClientId = sanitize_text_field($_POST['liveClientId']);
	$liveSecretKey = sanitize_text_field($_POST['liveSecretKey']);

	if ($_GLOBALS['paypal_cpt']=='paypalpayments'&&(empty($liveEmailAddress)||empty($liveMerchantId)||empty($liveClientId)||empty($liveSecretKey))){
		add_action( 'admin_notices', 'my_alert2');
		return;
	}

	if(!empty($liveEmailAddress)){
		update_post_meta($post_id, '_liveEmailAddress', $liveEmailAddress);
	}
	if(!empty($liveMerchantId)){
		update_post_meta($post_id, '_liveMerchantId', $liveMerchantId);
	}
	if(!empty($liveClientId)){
		update_post_meta($post_id, '_liveClientId', $liveClientId);
	}
	if(!empty($liveSecretKey)){
		update_post_meta($post_id, '_liveSecretKey', $liveSecretKey);
	}

	$ppcategory = sanitize_text_field($_POST['ppcategory']);
	update_post_meta($post_id, '_ppcategory', $ppcategory);

	$forsite = $_POST['forsite'];
	$forsites = $_POST['forsites'];
	//$ppoptions = get_paypal_options();//obtiene del servidor paypal
	$ppoptions = get_option('_paypal_options');//obtiene del sitio actual ESTAMOS EN EL SERVIDOR

	if(is_multisite()){
		if(!is_null($forsite)){
			update_post_meta($post_id, '_forsite', $forsite); //no tocar
			update_post_meta($post_id, '_forsites', array('0'=>$forsite[0])); //no tocar
		}
		if(!is_null($forsites)){
			update_post_meta($post_id, '_forsites', $forsites);
			update_post_meta($post_id, '_forsite', $forsites);
		}
	}
	$ppactivesales = sanitize_text_field($_POST['ppactivesales']);
	if(!empty($ppactivesales)){
		update_post_meta($post_id, '_ppactivesales', $ppactivesales);
	} 
	$ppdaysales = sanitize_text_field($_POST['ppdaysales']);
	if(!empty($ppdaysales)){
		update_post_meta($post_id, '_ppdaysales', $ppdaysales);
	} 
	$ppmonthlimit = sanitize_text_field($_POST['ppmonthlimit']);
	if(!empty($ppmonthlimit)){
		update_post_meta($post_id, '_ppmonthlimit', $ppmonthlimit);
	}
	$pplifetimesalessales = sanitize_text_field($_POST['pplifetimesales']);
	if(!empty($pplifetimesales)){
		update_post_meta($post_id, '_pplifetimesales', $pplifetimesalessales);
	}
	$ppstatus = sanitize_text_field($_POST['ppstatus']);
	update_post_meta($post_id, '_ppstatus', $ppstatus);

	return true;
}

add_action('save_post', 'paypal_save_meta_boxes');

/**
 * 2.4 Aumentar columnas personalizadas en la tabla
 */

function personalizar_columnas1( $columns ) 
{
	if(is_multisite()){
		//cambiar a countries para multiselect
		//$ppoptions=get_paypal_options();
		//$m=$ppoptions['multiple_countries']=='M'?true:false; //Estoy en servidor
		//$country = $m?'countries':'country';
		//$options = get_option('_paypal_options');
		$options=get_paypal_options();
		$country = $options['multiple_countries']=='M'?'countries':'country';

		$columns1 = array(
		  'username' => __( 'User Name', 'paypals' ),
		  $country => __( ucfirst($country), 'paypals' ),
		  'ppactivesales' => __( 'Active Sales', 'paypals' ),
		  'ppdaysales' => __( 'Today Sales', 'paypals' ),
		  'ppmonthsales' => __( 'Monthly Sales', 'paypals' ),
		  'pplifetimesales' => __( 'All Sales', 'paypals' ),
		  'ppmonthlimit' => __( 'Limit', 'paypals' ),
		  'ppstatus' => __( 'Paypal Status', 'paypals' )
		);
		if($options['multiple_countries']=='M'){
			$columns1['ppactiveinsites']= __( 'Active in sites', 'paypals' );
		};

	}else{
		$columns1 = array(
		  'username' => __( 'User Name', 'paypals' ),
		  'ppactivesales' => __( 'Active Sales', 'paypals' ),
		  'ppdaysales' => __( 'Today Sales', 'paypals' ),
		  'ppmonthsales' => __( 'Monthly Sales', 'paypals' ),
		  'pplifetimesales' => __( 'All Sales', 'paypals' ),
		  'ppmonthlimit' => __( 'Limit', 'paypals' ),
		  'ppstatus' => __( 'Paypal Status', 'paypals' ),
		);
	}

	$columns=array_merge($columns, $columns1);
  return $columns;
}//function personalizar columna END

add_filter( 'manage_paypals_posts_columns', 'personalizar_columnas1');

function admin_style1() 
{
echo "<style>.column-username {width:300px;} .column-primary {width:300px;}</style>";
}
add_action('admin_enqueue_scripts', 'admin_style1');


/**
 * 2.5 Definir el contenido a mostrar en las columnas
 */

function personalizar_contenido_columna( $column, $post_id ) 
{
  $info = get_post_meta($post_id);
  $info1 = get_post($post_id);
  switch ($column)
  {
	case 'username':
		$color=paypal_color_span($info['_ppcategory'][0]);
		echo $color.$info[$GLOBALS['_user_email_name']][0];
	  break;
	case 'countries':
		//$blog_id = get_current_blog_id();
		$sites=get_post_meta($post_id,'_forsites');
		$salida="";
		if(!empty($sites[0])){
			foreach($sites[0] as $site){
				switch_to_blog( $site);
				$optblogname = get_option( 'blogname' );
				$salida.="<span style='background-color:azure;border:solid gray 1px;border-radius:3px;font-size:10px;margin-left:3px;padding:0px 3px 0px 3px'>".$optblogname."</span>";
				restore_current_blog();
			}
		}//if sites false END
		echo $salida;
	  break;
	case 'country':
		//$blog_id = get_current_blog_id();
		$site=get_post_meta($post_id,'_forsite',true);
		$salida="";
		if(!empty($site)){
			switch_to_blog( $site);
				$optblogname = get_option( 'blogname' );
				$salida.="<span style='background-color:azure;border:solid gray 1px;border-radius:3px;font-size:10px;margin-left:3px;padding:0px 3px 0px 3px'>".$optblogname."</span>";
			restore_current_blog();
		}else{
			$salida.="<span style='background-color:azure;border:solid gray 1px;border-radius:3px;font-size:10px;margin-left:3px;padding:0px 3px 0px 3px'>Sin sitio</span>";
		}//if sites false END
		echo $salida;
	  break;
	case 'ppactiveinsites':
		//$blog_id = get_current_blog_id();
		$sites=get_post_meta($post_id,'_ppactiveinsites');
		$salida="";
		if(!empty($sites[0])){
			foreach($sites[0] as $site){
				switch_to_blog( $site);
				$optblogname = get_option( 'blogname' );
				$salida.="<span style='background-color:PaleGreen;border:solid gray 1px;border-radius:3px;font-size:10px;margin-left:3px;padding:0px 3px 0px 3px'>".$optblogname."</span>";
				restore_current_blog();
			}
		}//if sites false END
		echo $salida; 
	  break;
	case 'ppactivesales':
		echo $info['_ppactivesales'][0];
	  break;
	case 'ppdaysales':
		echo $info['_ppdaysales'][0];
	  break;
	case 'ppmonthsales':
		echo $info['_ppmonthsales'][0];
	  break;
	case 'pplifetimesales':
		echo $info['_pplifetimesales'][0];
	  break;
	case 'ppmonthlimit':
		echo $info['_ppmonthlimit'][0];
	  break;
	case 'ppstatus':
		echo $info['_ppstatus'][0];
	  break;
  }
}//function personalizar contenidos END

add_action( 'manage_paypals_posts_custom_column', 'personalizar_contenido_columna', 10, 2);

/**
 * 2.6 Columnas ordenables
 * Tres funciones: keys_sortable_columns, keys_load, my_sort_keys
 */
// Nombra la columna que sera ordenable
function keys_sortable_columns( $columns ) 
{
 $columns['ppstatus'] = 'Paypal Status';
 $columns['country'] = 'Paypal Country';
 return $columns;
}//function keys sortable columns END

add_filter( 'manage_edit-paypals_sortable_columns', 'keys_sortable_columns' );

/* Only run our customization on the 'edit.php' page in the admin. */
// En edit.php pone el mecanismo de ordenacion
function keys_load() 
{
 add_filter( 'request', 'my_sort_keys');
}//function keys load END 

/* Sorts  paypals. */
function my_sort_keys( $vars ) 
{
	/* Check if we're viewing the 'paypals' post type. */
	if ( isset( $vars['post_type'] ) && 'paypals' == $vars['post_type'] ) {
		/* Check if 'orderby' is set to 'ppstatus'. */
		if ( isset( $vars['orderby'] ) && 'Paypal Status' == $vars['orderby'] ) {
			/* Merge the query vars with our custom variables. */
			$vars = array_merge(
			$vars,
			array(
				 'meta_key' => '_ppstatus',
				 'orderby' => 'meta_value'
				)
				//meta_value_num
			);
		}

		if ( isset( $vars['orderby'] ) && 'Paypal Country' == $vars['orderby'] ) {
			/* Merge the query vars with our custom variables. */
			$vars = array_merge(
			$vars,
			array(
				 'meta_key' => '_forsite',
				 'orderby' => 'meta_value'
				)
				//meta_value_num
			);
		}
	}
 return $vars; 
}//function my sort keys END		

add_action( 'load-edit.php', 'keys_load');



/**
 * 2.7 Añade metadatos (en inputs) al Quick edit
 * https://rudrastyh.com/wordpress/quick-edit-tutorial.html
 */

function paypals_quick_edit_fields( $column_name, $post_type ) 
{
	switch( $column_name ) {
		case 'inline-edit-status': 
				echo "naranjas!";
			break;
		case 'ppstatus': 
			$ppstatus = get_post_meta($post->ID, '_ppstatus', true);
			?>
				<fieldset class="inline-edit-col-left">
					<div class="inline-edit-col-ps">
						<label>
							<span class="title">Papal Status</span>
							<select name="ppstatus" id="ppstatussel">
								<?php $selected=$ppstatus=='Activo'?'selected':'';?>
								<option id="Activo" value="Activo" <?php echo $selected;?> >Activo</option>
								<?php $selected=$ppstatus=='Reserva'?'selected':'';?>
								<option id="Reserva" value="Reserva" <?php echo $selected;?> >Reserva</option>
								<?php $selected=$ppstatus=='En_revision'?'selected':'';?>
								<option id="En_revision" value="En_revision" <?php echo $selected;?>>En_revision</option>
							</select>
						</label>
					</div>
				</fieldset>
<script>
jQuery( function( $ ){
	const wp_inline_edit_function = inlineEditPost.edit;
	// we overwrite the it with our own
	inlineEditPost.edit = function( post_id ) {
		// let's merge arguments of the original function
		wp_inline_edit_function.apply( this, arguments );
		// get the post ID from the argument
		if ( typeof( post_id ) == 'object' ) { // if it is object, get the ID number
			post_id = parseInt( this.getId( post_id ) );
		}
		// add rows to variables
		const edit_row = $( '#edit-' + post_id )
		const post_row = $( '#post-' + post_id )
		const ppstatus = $( '.column-ppstatus', post_row ).text()
		// populate the inputs with column data
		if(ppstatus!='Activo'){
			$('#ppstatussel').empty()
			.append('<option value="Reserva">Reserva</option>')
			.append('<option value="En_revision">En revision</option>')
			;
		}
		$('div.inline-edit-col-ps select').val(ppstatus).change();
	}
});
</script>
				<?php
			break;
	}
}

add_action( 'quick_edit_custom_box',  'paypals_quick_edit_fields', 10, 2 );

/**
 * 2.8 Añade un input select por status en la fila de filtros del listado CPT
 */

function ppstatus_filtering($post_type)
{
	if($GLOBALS['paypal_cpt'] !== $post_type){
	  return; //filter your post
	}
	$selected = '';
	$request_attr = 'paypal_status';
	if ( isset($_REQUEST[$request_attr]) ) {
	  $selected = $_REQUEST[$request_attr];
	}
	//get unique values of the meta field to filer by.
	$meta_key = '_ppstatus';
	global $wpdb;
	
	$result = $wpdb->get_results( 
		$wpdb->prepare( "SELECT DISTINCT meta_value FROM {$wpdb->prefix}postmeta WHERE meta_key = '_ppstatus'" 
		) 
	);
   //build a  custom dropdown list of values to filter by
	echo '<select id="paypal_status" name="paypal_status">';
	echo '<option value="-1">' . __( 'Show all status', 'paypals' ) . ' </option>';
	foreach($result as $location){
	  //$select = ($org->ID == $selected) ? ' selected="selected"':'';
	  if ($location->meta_value<>""){
		  $select = ($location->meta_value == $selected) ? ' selected="selected"':'';
		echo '<option value="'.$location->meta_value.'"'.$select.'>' . $location->meta_value . ' </option>';
	  }
	}
	echo '</select>';
  }

add_action('restrict_manage_posts','ppstatus_filtering');

/**
 * 2.9 Añade un input select por country en la fila de filtros del listado CPT
 */
function country_filtering($post_type)
{
	if($GLOBALS['paypal_cpt'] !== $post_type){
	  return; //filter your post
	}
	$selected = '';
	$request_attr = 'paypal_country';
	if ( isset($_REQUEST[$request_attr]) ) {
	  $selected = $_REQUEST[$request_attr];
	}
	//get unique values of the meta field to filer by.
	$meta_key = '_forsite';
	global $wpdb;
	
	$result = $wpdb->get_results( 
		$wpdb->prepare( "SELECT DISTINCT meta_value FROM {$wpdb->prefix}postmeta WHERE meta_key = '_forsite'" 
		) 
	);
   //build a  custom dropdown list of values to filter by
	echo '<select id="paypal_country" name="paypal_country">';
	echo '<option value="-1">' . __( 'Show all sites', 'paypals' ) . ' </option>';
	echo '<option value="0">' . __( 'Show "Sin sitio"', 'paypals' ) . ' </option>';
	foreach($result as $location){
	  //$select = ($org->ID == $selected) ? ' selected="selected"':'';
	  $select = ($location->meta_value == $selected) ? ' selected="selected"':'';
	  switch_to_blog($location->meta_value);
	  $nom_sitio=get_option('blogname');
	  restore_current_blog();
	  echo '<option value="'.$location->meta_value.'"'.$select.'>' . $nom_sitio . ' </option>';
	}
	echo '</select>';
  }
add_action('restrict_manage_posts','country_filtering');

/**
 * 3.0 El mecanismo del filtro (the ‘parse_query’ filter)
 */

function paypals_filter_request_query($query)
{
	//modify the query only if it admin and main query.
	//if( !(is_admin() AND $query->is_main_query()) ){ 
	if( $query->is_main_query() ){ 
	  //return $query;
	}

	//we want to modify the query for the targeted custom post and filter option
	if( !($GLOBALS['paypal_cpt'] === $query->query['post_type'] AND isset($_REQUEST['paypal_status']) ) ){
	//we want to modify the query for the targeted custom post and filter option
		if( !($GLOBALS['paypal_cpt'] === $query->query['post_type'] AND isset($_REQUEST['paypal_country']) ) ){
		  return $query;
		}
	}
	//for the default value of our filter no modification is required
	if('-1' === $_REQUEST['paypal_status']){
		set_query_var('_ppstatus', false);
		$salir=true;
	}else{
		//List posts this user is "tagged" in (B).
		$metaquery1=array('key' => '_ppstatus', 'value' => $_REQUEST['paypal_status'],'compare' => '=' );
	}
	//for the default value of our filter no modification is required
	if('-1' == $_REQUEST['paypal_country']){
	  set_query_var('_forsite', false);
		$salir1=true;
	}else{
		//List posts this user is "tagged" in (B).
		$metaquery2=array('key' => '_forsite', 'value' => $_REQUEST['paypal_country'],'compare' => '=' );
	}
	if($salir&&$salir1){
	  return $query;
	}else{
		$metaquerys=array($metaquery1, $metaquery2);
		$query->set('meta_query',$metaquerys);
	}

	return $query;
  }

add_filter( 'parse_query', 'paypals_filter_request_query');

/**
 * 3.1 quitar opciones view, quick edit, y otros de cada fila de los cpt
 */
 
function quita_opciones_view($actions, $post)
{
    if ($post->post_type=='paypals')
    {
        //$actions['duplicate'] = '<a href="#" title="" rel="permalink">Duplicate</a>';
		unset($actions['view']);
		unset($actions['inline hide-if-no-js']);    
	}
	return $actions;
}
add_filter('post_row_actions', 'quita_opciones_view', 10, 2);